/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@ricochet.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2004 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.venice.ui.velocity;

import com.silverwrist.venice.ui.Content;

public interface ContentVelocity extends Content, VelocitySupplyParams
{
  /**
   * Returns the resource name of the Velocity template to be used in rendering this object.  This pathname
   * is interpreted relative to the "template path" specified in the configuration.
   * The template engine loads it via the standard resource loader, and then applies the parameters
   * contained in this object to it.
   *
   * @return The resource pathname of the Velocity template to use.
   */
  public String getTemplateName();

} // end interface ContentVelocity
